#!/bin/sh

. /etc/utils/shell-utils.sh
#DEBUG=0

retVal=0
#LOG_FILE=/ram/wifi/logs/messages.log
WIFI_STARTUP_SCRIPT=/etc/init.d/wifi.sh
WIFI_DRIVER_MODULE_NAME="ralink"

_check_lock_and_delete()
{
  if [ $LOCK_OWNED -gt 0 ]; then
    #log "Lock owned. Deleting lock..."
    rm -f $LOCK_FILE
  fi
}

_exit()
{
  #_check_lock_and_delete

  exit 0;
}
_error()
{
  exit 1;
}

_export_wifi_settings()
{
exit
    export wifi_en=1
    export wifi_mode="n"
    export wifi_ch=7
    export wifi_ssid="wtfomg"
    export wifi_psk="11111111"
    export wifi_enc="aes"
    export wifi_auth="wpa2psk"
    export wifi_int_ip="192.168.67.100"
    export wifi_int_mask="255.255.255.0"
    export wifi_int_gw="192.168.67.1"
    export wifi_int_dns="192.168.67.1"
}

_export_vendor_id()
{
  #log "_export_vendor_id()*. \$1=$1, \$2=$2"
  # VID(0b05) = ASUS?
  #   PID(1784) = USB-N13
  # VID(0cf3) = TP-LINK
  #   PID(9170) = TL-WN821N

  if [ "$1" == "0b05" ]; then
    log "found vendor = ASUS(0x0b05)"
    if [ "$2" == "1784" ]; then
      log "found product = USB-N13(0x1784)"
      export wifi_driver=$WIFI_DRIVER_MODULE_NAME
      retVal=1
      return
    fi
  fi

  if [ "$1" == "07d1" ]; then
    log "found vendor = D-Link System (0x07d1)"
    if [ "$2" == "3c0d" ]; then
      log "found product = DWA-125 Wireless 150 USB Adapter"
      export wifi_driver=$WIFI_DRIVER_MODULE_NAME
      retVal=1
      return
    fi
  fi

  if [ "$1" == "07d1" ]; then
    log "found vendor = D-Link System (0x07d1)"
    if [ "$2" == "3c16" ]; then
      log "found product = DWA-125 Wireless N 150 Adapter (rev.A2)"
      export wifi_driver=$WIFI_DRIVER_MODULE_NAME
      retVal=1
      return
    fi
  fi

  if [ "$1" == "2001" ]; then
    log "found vendor = D-Link System (0x07d1)"
    if [ "$2" == "3c19" ]; then
      log "found product = DWA-125 Wireless N 150 Adapter (rev.A3)"
      export wifi_driver=$WIFI_DRIVER_MODULE_NAME
      retVal=1
      return
    fi
  fi

  if [ "$1" == "7392" ]; then
    log "found vendor = Edimax (0x7392)"
    if [ "$2" == "7711" ]; then
      log "found product = EW-7711UAn (0x7711)"
      export wifi_driver=$WIFI_DRIVER_MODULE_NAME
      retVal=1
      return
    fi
  fi

  if [ "$1" == "148f" ]; then
    log "found vendor = Ralink Technology, Corp. (0x148f)"
    if [ "$2" == "3070" ] || [ "$2" == "5370" ]; then
      log "found product = RT2870/RT3070 Wireless Adapter (0x3070)"
      export wifi_driver=$WIFI_DRIVER_MODULE_NAME
      retVal=1
      return
    fi
  fi

  export wifi_driver=
  retVAL=0;
}

# EXECUTION POINT

if [ "$UDEV_ACTION" == "" ]; then
  log "UDEV_ACTION not set"
  _error
fi

if [ "$USB_VENDOR_ID" == "0000" ]; then
  log "USB_VENDOR_ID not set"
  _error
fi

_export_vendor_id $USB_VENDOR_ID $USB_PRODUCT_ID

if [ $retVal -ne 1 ]; then
    log "Current device not supported USB_VENDOR_ID=$USB_VENDOR_ID USB_PRODUCT_ID=$USB_PRODUCT_ID"
    _error
fi

log "UDEV_ACTION="$UDEV_ACTION", USB_VENDOR_ID="$USB_VENDOR_ID", USB_PRODUCT_ID="$USB_PRODUCT_ID

case $UDEV_ACTION in
  add)
      $WIFI_STARTUP_SCRIPT start
  ;;
  remove)
      $WIFI_STARTUP_SCRIPT stop
  ;;
  *)
    _error
  ;;
esac

_exit
