#!/bin/sh
tmpfile=/ram/SbootIm

if [ -f /ram/mag250 ]; then
   max=327680
else
   max=262144
fi

if [ "$1" != "" ]; then
  up_url=$1
  rm -f $tmpfile 2>/dev/null 1>/dev/null

  URL_HTTP=`echo $up_url |awk '{ if($1~/^http:\/\//) {print $1; exit; } }'`
  TFTP_IP=`echo $up_url |awk '{ if($1~/^tftp:\/\//) { tmp = substr($1,8); i=index(tmp,"/"); print substr(tmp,1,i-1); exit; } }'`
  TFTP_ROOTPATH=`echo $up_url |awk '{ if($1~/^tftp:\/\//) { tmp = substr($1,8); i=index(tmp,"/"); print substr(tmp,i+1); exit; } }'`
  
  if [ "$URL_HTTP" == "" ]; then
    if [ "$TFTP_IP" == "" ] || [ "$TFTP_ROOTPATH" == "" ]; then
      tmpfile=$up_url;
    else
      /bin/tftp -l /proc/self/fd/1 -g -r $TFTP_ROOTPATH $TFTP_IP 2>/dev/null | dd of=$tmpfile bs=1 count=$max 2>/dev/null 1>/dev/null
    fi
  else
    /bin/wget $URL_HTTP  -O /dev/stdout 2>/dev/null | dd of=$tmpfile bs=1 count=$max 2>/dev/null 1>/dev/null
  fi
  par=$tmpfile
else
  par=./SbootIm
fi

if [ ! -e $par ]; then
  echo "Error: File $par not present!!!"
  exit 1    
fi

f=`wc -c $par`
size=${f%%$par}
size=$((size))

echo $size

if [ $size -eq 0 ]; then
    echo "ERROR: Uploading is failed."
    exit 1;
fi
if [ $max -lt $size ]; then
    echo "ERROR: File size more then $max."
    exit 1;
fi

dd if=/dev/mtd1 of=/ram/mtd1 bs=1 count=$size
diff $par  /ram/mtd1 > /dev/null
if [ "$?" == "0" ]; then
  echo "Second image of bootloader is up to date"
else
  flash_eraseall /dev/mtd1
  cat $par > /dev/mtd1
fi
rm -f /ram/mtd1 2>/dev/null 1>/dev/null

tmp=`fw_printenv bootupgrade 2>/dev/null`
tmp=${tmp#bootupgrade=}
if [ "$tmp" != "yes" ]; then
  fw_setenv bootupgrade yes
fi
exit 0
